/**
 * Title :        XLogo
 * Description :  XLogo is an interpreter for the Logo 
 * 						programming language
 * @author Loïc Le Coq
 */
package xlogo.kernel;
import java.util.Stack;

import xlogo.utils.myException;
import xlogo.Application;
import xlogo.Logo;
public class Interprete{

  private LaunchPrimitive lanceprim;
  private Application app;
  private Kernel kernel;
  private Workspace wp;
  protected static boolean renvoi_instruction=false; // Si une primitive renvoie une série d'instruction à évaluer (si, exec).
  public static Stack calcul=new Stack();   //Pile contenant les   nombres
  protected static Stack stockvariable=new Stack();
  protected static boolean stop=false;
  protected static Stack nom=new Stack();  //contient les noms des procédures attendant parmamètres à recevoir
  public static Stack en_cours=new Stack(); //contient les procédures actuellement en cours d'exécution
  public static StringBuffer instruction=new StringBuffer();       // String contenant les chaînes représentant les instructions

  protected static Stack locale=new Stack();            // Pile contenant les noms des variables locales
  protected static Stack valeur = new Stack();          // Pile contenant les valeurs de ses variables.

  protected static boolean operande=false;     // si l'élément trouvé est un nombre
  protected static boolean operateur=false;    //si l'élément trouvé est un opérateur
  protected static boolean drapeau_ouvrante=false;   //si l'élément trouvé est une parenthèse ouvrante
  protected static boolean drapeau_fermante=false; //si l'élément trouvé est une parenthèse fermante
/*  public Interprete(Application cadre){
    this.cadre=cadre;
    
    lanceprim=new LaunchPrimitive(cadre);
    cadre.error=false;
   }*/
  public Interprete(Application app){
    this.kernel=app.getKernel();
    this.app=app;
    wp=kernel.getWorkspace();
    lanceprim=new LaunchPrimitive(app,wp);
    app.error=false;
   }
  
  
  
  String execute(StringBuffer instructions) throws myException{    // identifie une expression arithmétique
    if (!instructions.equals("")) {
      if (instruction.length()==0) instruction.append(instructions);
      else  instruction.insert(0,instructions);
    }

//    Object obca1,obca2,oban;
    while (instruction.length()!=0){
      	if (app.error&&myException.lance) throw new myException(app,Logo.messages.getString("stop"));
      while (app.affichage.isOnPause()){ // Si l'on touche aux scrollbars
        try{wait();}
        catch(Exception e){}
      }
//System.out.println("en_cours d'execution "+ en_cours);
//System.out.print("debut\n"+instruction+"fin\n");
//System.out.println("nom "+nom);
//System.out.println("calcul "+calcul);
//System.out.println("nom "+nom.toString()+" locale "+locale+ " "+valeur+" stockvariable "+stockvariable);
//System.out.println("operande  "+calcul+" "+operande+"debut "+instruction);

      if (instruction.length()==0) break;
      String element=getNextWord();

      
   //   System.out.println("a"+element+"a");
      if (element=="") break;
//System.out.println(element);
    //si c'est une primitive ou une procedure
    String element_minuscule=element.toLowerCase();
      int i=isProcedure(element_minuscule);

      if (Primitive.primitives.containsKey(element_minuscule)||i>-1){
    	  drapeau_ouvrante=false;
        //identifiant de la primitive
        if (i==-1) i=Integer.valueOf(Primitive.primitives.get(element_minuscule).toString()).intValue()%Primitive.PRIMITIVE_NUMBER;
        else i=-i-2;
       //if (!calcul.empty()&&nom.isEmpty()) 
       	//throw new monException(cadre,Logo.messages.getString("que_faire")+" "+calcul.pop() +" gdfdsf");
       //exécuter la procédure ou la primitive.
        if (false) ;
        else{
          Stack param=new Stack();
          if (29<i&&i<39) {        // Si c'est un opérateur infixé
            operateur=true; 
            operande=false;
            if (drapeau_ouvrante) {
            	drapeau_ouvrante=false;

              if (i!=32&&i!=33) throw new myException(app,element+" "+Logo.messages.getString("ne_peut_etre"));
              else param.push("0");
            }
            else if (calcul.isEmpty()) {       // Si le + ou le - représente le signe négatif ou positif
              if (i!=32&&i!=33) throw new myException(app,element+" "+Logo.messages.getString("ne_peut_etre")); // d'un nombre
              if (nom.isEmpty()) param.push("0");
              else {
                String st=nom.peek().toString();
                if (!testoperateur(st)) param.push("0");
                else if ("*/".indexOf(st)>-1) {     // Si le signe - ou + suit un * ou /
                  deleteFirstWord(element);
                  if (st.equals("*")) instruction.insert(0,"* ");
                  else instruction.insert(0,"/ ");
                  if (i==32) return("1");     // Si c'est un plus
                  else return("-1");          //Si c'est un moins
                }
                else param.push("0");
              }
            }
            else if (nom.isEmpty()){
              param.push(calcul.pop());
            }
            else {
              String st=nom.peek().toString();
              if (testoperateur(st)){
		//						System.out.println("st "+st+" element "+element+" "+prioriteinf(st,element));
                if (prioriteinf(st,element)){
                  param.push(calcul.pop());
                }
                else return(calcul.pop().toString());
              }
              else param.push(calcul.pop());
            }
          }
          else if (operande&&i!=204) {operande=false;break;} // Si ce n'est pas l'opérateur de fin de parenthèse, on sort
          
          /*         
 * operateur=false;
          parenthese=false;
          operande=false;*/
          deleteFirstWord(element);
          int nbparametre=0;
          if (i>-1) nbparametre=kernel.primitive.parametres[i];
          else nbparametre=wp.getProcedure(-i-2).nbparametre;
          int j=0;
          
          nom.push(element);
          // Recherche du nombre de paramètres désirés.
          while (j<nbparametre){
            try{
              operande=operateur=drapeau_ouvrante=false;
              String  a=execute(new StringBuffer());
          //    System.out.println(nom);
/*              if (drapeau_fermante) {
              	// On enleve le \n de la pile nom
              	System.out.println(nom);
              	drapeau_fermante=false;nom.pop();	
              }*/
              param.push(a);
              j++;
            }
            catch(myException e){throw e;}
          }

////////////////////////////////////////////////////////////////////////////////////////////
   //       System.out.println(nom+" "+"debut "+instruction+" fin\n"+param.toString());
   //       System.out.println(nom);
          nom.pop();
          if (!app.error) lanceprim.execute(i,param);
          if (app.error) break;
          if (drapeau_fermante&&!calcul.empty()) {
          	drapeau_fermante=false;
          	operande=false;
          	return calcul.pop().toString();
          }

          // Tester si la procédure rend quelque chose lorsqu'attendu
         /* if (operande){
          
            if (nom.isEmpty()) throw new monException(cadre,Logo.messages.getString("que_faire")+" "+calcul.pop().toString()+" ?");
          }*/
          
      	// dans le cas des primitives exec ou si 
          if (!operande) {
          	if (renvoi_instruction) {
          		renvoi_instruction=false;
          	}
          	else{
          		if (!nom.isEmpty()&&!app.error&&!nom.peek().toString().equals("\n")){
          			if (!element.equals("\n")){
          				// Si c'est une fin de boucle
          				// repete 2 [td 90 av]
          				if (element.equals("\\")){
          					throw new myException(app,Logo.messages.getString("pas_assez_de")+" "+nom.peek().toString());
          				}
          				// av av 20
          				throw new myException(app,element+" "+Logo.messages.getString("ne_renvoie_pas")+" "+nom.peek().toString());
          			}
          		}
          	}
          }
        }
      }

/////////////  // Si c'est une variable
      else if (element.substring(0,1).equals(":")&&element.length()>1){
 //       System.out.println(operande);
        if (operande) {operande=false;break;}
        Object value;
        String nomvariable=element_minuscule.substring(1,element_minuscule.length());
        int id=locale.search(nomvariable);
        if (id==-1) {
          id=wp.searchVariable(nomvariable);
          if (id==-1) throw new myException(app,nomvariable+" "+Logo.messages.getString("pas_de_valeur"));
          else value=wp.valeur.get(wp.globale.size()-id);
        }
        else {value=valeur.get(locale.size()-id);}
        if (null==value) throw new myException(app,nomvariable+"  "+Logo.messages.getString("pas_de_valeur"));
        calcul.push(value);
        operande=true;
        operateur=false;
        drapeau_ouvrante=false;
        deleteFirstWord(element);
      }
      else{
//Si c'est un nombre
        try {
        	Double.parseDouble(element);
        	String fin_entier="";
          if (element.endsWith(".0")) {fin_entier=".0";element=element.substring(0,element.length()-2) ;}
          if (element.startsWith(".")||element.equals("")) element="0"+element;
          calcul.push(element);
          if (operande) {calcul.pop();operande=false;break;}
          operande=true;
          operateur=false;
          drapeau_ouvrante=false;
          deleteFirstWord(element+fin_entier);
        }
        catch(NumberFormatException e){
// Si c'est un crochet ouvrant
          if (element.equals("[")){
  
          	//Utilité de cette ligne?
          	//if (!calcul.isEmpty()&&operateur==false) break;
            if (operande) {break;}
            operande=true;
            operateur=false;
            drapeau_ouvrante=false;
            deleteFirstWord(element);
            String a=chercheListe();
            calcul.push(a);
          }
// Si parenthèse ouvrante
          else if (element.equals("(")) {
          	if (operande) break; 
          	drapeau_ouvrante=true;
			Interprete.en_cours.push("(");
            int pos=chercheParenthese();
            if (pos==-1){
            	try{throw new myException(app,Logo.messages.getString("parenthese_fermante"));}
            	catch(myException e1){}
            }
          	deleteFirstWord(element);
//            System.out.println("&&"+instruction);
            Interprete.nom.push("(");            
          }
//Si c'est un mot
          else if (element.substring(0,1).equals("\"")){
            try{
            	String el=element.substring(1);
            	double d=Double.parseDouble(el);
            	calcul.push(el);
            }
          	catch(NumberFormatException e1){calcul.push(element);}
            if (operande) {calcul.pop();operande=false;break;}
            operande=true;
            operateur=false;
            drapeau_ouvrante=false;
            deleteFirstWord(element);
          }


// Si c'est le mot pour
          else if (element_minuscule.equals(Logo.messages.getString("pour"))){
            deleteFirstWord(element);
            if (instruction.length()!=0) element=getNextWord().toLowerCase();
            else throw new myException(app,Logo.messages.getString("pas_assez_de")+" "+"\""+Logo.messages.getString("pour")+"\"");
            if (Primitive.primitives.containsKey(element_minuscule)||isProcedure(element_minuscule)!=-1) throw new myException(app,element+" "+Logo.messages.getString("existe_deja"));
            else {
              String definition=Logo.messages.getString("pour")+" "+element+" ";
              deleteFirstWord(element);
              while(instruction.length()!=0){
                element=getNextWord().toLowerCase();
                if (null==element) break;
                if (!element.substring(0,1).equals(":")||element.length()==1) throw new myException(app,element+" "+Logo.messages.getString("pas_argument"));
                definition+=element+" ";
                deleteFirstWord(element);
              }
              if (app.editeur.isVisible()) throw new myException(app,Logo.messages.getString("ferme_editeur"));
              else {app.editeur.setVisible(true);app.editeur.setEditorText(definition+"\n"+Logo.messages.getString("fin"));}
            }
          }
// Si c'est le mot ed
          else if (element_minuscule.equals("ed")){
            deleteFirstWord(element);
            if (!app.editeur.isVisible()) {
              Stack a_editer=null;
              if (instruction.length()!=0&&getNextWord().equals("[")) {
                a_editer=new Stack();
                deleteFirstWord("[");
                while(instruction.length()!=0){String el=getNextWord().toLowerCase();a_editer.push(el);deleteFirstWord(el);}
              }
              for(int ij=0;ij<wp.getNumberOfProcedure();ij++){
                Procedure procedure=wp.getProcedure(ij);
                if ((null==a_editer||a_editer.search(procedure.name)!=-1)&&procedure.affichable) {
                  app.editeur.setEditorStyledText(Logo.messages.getString("pour")+" "+procedure.name);
                  for (int j=0;j<procedure.nbparametre;j++){
                    app.editeur.setEditorStyledText(" :"+procedure.variable.get(j).toString());
                  }
                  app.editeur.setEditorStyledText("\n"+procedure.instruction+Logo.messages.getString("fin")+"\n\n");
                }
              }
              app.editeur.setTitle(Logo.messages.getString("editeur"));
              app.editeur.setVisible(true);
              app.editeur.toFront();
            }

          }
          else throw new myException(app,Logo.messages.getString("je_ne_sais_pas")+" "+element);
        }
      }
 //   System.out.println("instruction "+instruction+" calcul "+calcul);
    }

    // Fin de la boucle while principale

    // S'il n'y a rien à retourner. 
    if (calcul.isEmpty()){
      if (!nom.isEmpty()){//&&!nom.peek().equals("\n")) {
        while ((!nom.isEmpty())&&nom.peek().equals("\n")) nom.pop();
        if (!nom.isEmpty()) {throw new myException(app,Logo.messages.getString("pas_assez_de")+" "+nom.peek());}
      }
    }
    // Sinon on retourne la valeur contenue dans la pile de calcul.
    if (!calcul.isEmpty()) {
    	// S'il y a une procédure de lancer 
    	// Ex: pour t -- 6 -- fin . Puis, av t.
    	if ((!nom.isEmpty())&&nom.peek().equals("\n")){
    		String up="";
    		nom.pop();
    		if (!nom.isEmpty()&&nom.peek().equals("\n")) up=en_cours.get(en_cours.size()-2).toString();
    		else up=nom.peek().toString();
			try{
				throw new myException(app,en_cours.peek()+" "+Logo.messages.getString("ne_renvoie_pas")+" "+up);
			}
			catch(myException e){}
    	}
    	/////////////
    	else {
    		operande=false;return(calcul.pop().toString());
    	}
    }
     return("");
  }

  private int chercheParenthese() { // position ou s'arrete la prochaine parenthese
	boolean continuer=true;
	int of_ouvrant;
	int of_fermant=0;
	int from_index_ouvrant=1;
	int from_index_fermant=1;
	while(continuer){
		of_ouvrant=instruction.indexOf("(",from_index_ouvrant);
		of_fermant=instruction.indexOf(")",from_index_fermant);
		if (of_fermant==-1) break;
		if (of_ouvrant!=-1 && of_ouvrant<of_fermant) {
			from_index_ouvrant=of_ouvrant+1;
			from_index_fermant=of_fermant+1;
		}
		else continuer=false;;
	}
	return of_fermant;
  }
  
  protected String chercheListe() throws myException{
    String liste="[ ";
    String element="";
    while (instruction.length()!=0){
      element=getNextWord();
      // SI crochet ouvrant, on l'empile dans la pile de calcul
      if (element.equals("[")) {calcul.push("[");deleteFirstWord(element);liste+="[ ";}

      else if (element.equals("]")){  // Si on atteint un crochet fermant
        deleteFirstWord(element);
        //if (((Stack)instruction.peek()).isEmpty()) instruction.pop();
        liste+="] ";
        if (calcul.empty()) {return(liste);}   // 1er cas: rien dans la pile de calcul, on renvoie la liste
        else if (!calcul.peek().toString().equals("[")) {return(liste);} //2eme cas: pas de crochet ouvrant en haut de la pile, idem
        else calcul.pop();  //3eme cas: un crochet ouvrant en haut de la pile, on l'enleve
      }
      else{
        deleteFirstWord(element);
        liste+=element+" ";
      }
    }
    if (true) throw new myException(app,Logo.messages.getString("erreur_crochet"));
    return(null);
  }

  private boolean testoperateur(String st){ // l'élément trouvé est-il un opérateur
    int i="+-*/<>=!&|".indexOf(st);
    if (i==-1) return(false);
    return(true);
  }

  private boolean prioriteinf(String pile,String str){                        // teste si le sommet de la pile d'analyse
 /*  if (parenthesefermante>0) return(false);					// est un opérateur de priorité strictement
    else*/
   	if ("*/".indexOf(str)>-1&&"*/".indexOf(pile)==-1) return (true);   // inférieure
    else if ("+-".indexOf(str)>-1&&"=<>|&".indexOf(pile)>-1) return(true); 
    else if ("=><".indexOf(str)>-1&&"|&".indexOf(pile)>-1) return(true);  
    return(false);
  }
  private int isProcedure(String mot){   // vérifie si mot est une procédure
    for (int i=0;i<wp.getNumberOfProcedure();i++){
      if (wp.getProcedure(i).name.equals(mot)) return(i);
    }
    return(-1);
  }
  protected static String getNextWord(){
    String mot="";
    char caractere;
    for (int i=0;i<instruction.length();i++){
      caractere=instruction.charAt(i);
      if (caractere==' ') {return mot;}
      else mot+=caractere;
    }
    //System.out.println("mot: "+mot);
    return mot;
  }
  protected static void deleteFirstWord(String mot){
    if (instruction.length()>mot.length()) instruction=instruction.delete(0,mot.length()+1);
    else instruction=new StringBuffer();
  }
  protected static void tueniveau(String car,Application app) throws myException{
    String caractere="";
    String car2=null;
    if (car.equals("\\")) car2="\n";  // Dans ce cas là on déroule jusqu'à la prochaine fin de boucle ou procédure
    int marqueur=0;
    for (int i=0;i<instruction.length();i++){
	//		System.out.println("a "+caractere);
      caractere=String.valueOf(instruction.charAt(i));
      if (caractere.equals(car)|caractere.equals(car2)) {
      		marqueur=i;
      		if (caractere.equals("\\")&&i!=instruction.length()-1){
      			/* On test si le caractère "\" est bien un caractère de
      			 * fin de boucle et non du style "\e" ou "\#"
      			 */
      			if (instruction.charAt(i+1)==' ') break;
      		}
      		else break;
      	}
    }
	//		System.out.println("a "+caractere);
	if (caractere.equals("")) {
		if (car2.equals("\n"))
			throw new myException(app, Logo.messages.getString("erreur_stop"));
		else
			throw new myException(app,Logo.messages.getString("erreur_retourne"));
	}
    if (marqueur+2>instruction.length()) instruction=new StringBuffer(" ");//instruction.substring(marqueur,instruction.length());
    else instruction=instruction.delete(0,marqueur+2);
    if (caractere.equals("\n")){
        Interprete.en_cours.pop();
        Interprete.valeur = (Stack) Interprete.stockvariable.pop();
        Interprete.locale = (Stack) Interprete.stockvariable.pop();
    }
    else{
      Primitive.stackLoop.pop();
    }
  }
  protected void setWorkspace(Workspace workspace){
  	wp=workspace;
  	lanceprim.setWorkspace(workspace);
  }
}